Status: Closed

Priority: Low

Assignee: nobody -

Category: Vectors

Affected QGIS version: Regression?: No

Operating System: Debian Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed

Crashes QGIS or corrupts data: Copied to github as #: 10997

Description

1. Add a [[PostGIS]] layer with varchar field.

2. "Open Table"

3. The varchar column name is not available in the combo box with column names in the bottom. An empty slot there instead.

4. If you select this empty one, enter a string in "Search for:" field ann press search, a "Search string parsing error:" windows pops up

which reads:

syntax error, unexpected COMPARISON

BTW - why is the "varchar(30)" forced in the add column dialog? If the lenght can't be made optional easily, why not force "varchar(256)"

instead and not force the user to use "text" for anything longer than 30 chars?

SVN r8110, built and running against QT 4.3.3 and QT 4.3.2 on the other machine.

History

#1 - 2008-02-14 04:48 PM - Steven Mizuno

I find that there is a blank item in the drop-down list AND the last column in the table is missing from the list. This doesn't occur for all tables. The missing

column may be of any type.

The blank list item follows a column used by QGIS for the feature id (the primary key or unique index, SERIAL4/INT4 type in the table) and that the last

column is not in the list. If the feature id is last there is no blank item.

The number of items in the list matches the number of columns that should be listed (the geometry column is not listed).

I am using Mandriva 2008.0 x86_64, QGIS commit:9c06f040 (SVN r8156) built against Qt 4.3.3, [[PostgreSQL]] 8.2.6/PostGIS 1.3.2

Also have checked with 0.9.1 (same building and on Windows XP, binary package) and it has the same problem.

#2 - 2008-02-14 07:44 PM - Steven Mizuno

I just realized that I wasn't paying attention to the position of the geometry column. It is at the position of the geometry column that the blank list item

occurs, not following the feature id column.
This can be shown by building a table where the feature id column is first, then a column of a type other than geometry, the geometry column, then two

more columns of a type other than geometry.

The drop-down list for this table will be blank in the position where the geometry column is, then the first column after the geometry column is present, and

the last column is missing.

#3 - 2008-02-18 05:48 PM - Steven Mizuno

On a further look at this problem: in [[QgsAttributeTableDisplay]] constructor where mSearchColumns is loaded the original code uses a standard C 'for'

loop using an index counter and the number of fields as a terminating condition. Then, the fields variable is accessed by index, resulting in the blank at the

position the geometry column is at and not accessing the last field.

I noticed that in qgsattributetable.cpp where the table header is loaded that an Iterator on a Map is used. I tried this idea to load mSearchColumns and it

works.

Refer to the attached patch for the changes.

I have tested the patch on [[PostGIS]] layers as well as shapefile layers.

#4 - 2008-02-19 12:44 AM - Marco Hugentobler

- Resolution set to fixed

- Status changed from Open to Closed

Thanks for this patch, smizuno! It is applied to svn now (commit:88c839a6 (SVN r8167)) with minor modifications (some additional consts).

Marco

#5 - 2009-08-22 12:54 AM - Anonymous

Milestone Version 0.9.2 deleted

Files

patch_for_bug_938.txt 753 Bytes 2008-02-18 Steven Mizuno
